Codeforces 723F st-Spanning Tree【贪心Kruskal】

来源:互联网 发布:网络gb是什么意思啊 编辑:程序博客网 时间:2024/06/17 06:57

F. st-Spanning Tree
time limit per test
4 seconds
memory limit per test
256 megabytes
input
standard input
output
standard output

You are given an undirected connected graph consisting of n vertices and m edges. There are no loops and no multiple edges in the graph.

You are also given two distinct vertices s andt, and two values ds anddt. Your task is to build any spanning tree of the given graph (note that the graph is not weighted), such that the degree of the vertexs doesn't exceed ds, and the degree of the vertext doesn't exceed dt, or determine, that there is no such spanning tree.

The spanning tree of the graph G is a subgraph which is a tree and contains all vertices of the graphG. In other words, it is a connected graph which containsn - 1 edges and can be obtained by removing some of the edges fromG.

The degree of a vertex is the number of edges incident to this vertex.

Input

The first line of the input contains two integers n andm (2 ≤ n ≤ 200 000,1 ≤ m ≤ min(400 000, n·(n - 1) / 2)) — the number of vertices and the number of edges in the graph.

The next m lines contain the descriptions of the graph's edges. Each of the lines contains two integersu and v (1 ≤ u, v ≤ n,u ≠ v) — the ends of the corresponding edge. It is guaranteed that the graph contains no loops and no multiple edges and that it is connected.

The last line contains four integers s,t, ds,dt (1 ≤ s, t ≤ n,s ≠ t, 1 ≤ ds, dt ≤ n - 1).

Output

If the answer doesn't exist print "No" (without quotes) in the only line of the output.

Otherwise, in the first line print "Yes" (without quotes). In the each of the next(n - 1) lines print two integers — the description of the edges of the spanning tree. Each of the edges of the spanning tree must be printed exactly once.

You can output edges in any order. You can output the ends of each edge in any order.

If there are several solutions, print any of them.

Examples
Input
3 31 22 33 11 2 1 1
Output
Yes3 21 3
Input
7 87 41 35 45 73 22 46 11 26 4 1 4
Output
Yes1 35 73 27 42 46 1

题目大意:

给你N个点,M条无向边,让你从中选出N-1条边,使得最终生成树中,点s的度数不超过ds,点t的度数不超过dt.

问是否存在一种构图方式。


思路:


1、首先我们可以将边分成两类:

①有s或者t作为一点的边:这类边的加入要有一定的条件。

②没有s或者t作为一点的边:这类边的加入不会影响结果,没有限定的条件,所以我们可以将其权值设定为0.

所以问题我们可以转化为给边设定权值的问题。剩余部分只要跑最小生成树贪心算法维护结果是否合法即可。


2、那么我们的问题关键点就在于如何设定类型①的边的权值。

接下来我们引入贪心思维,然后将问题再分成三类:

①ds>dt.那么我们肯定优先加入只有s点的边,然后次优先加入只有t的边,最后再加入既有s又有t的边。

过程 kruskal算法贪心加并查集维护即可。如果最终s点的度和t点的度都满足要求即为结果。

②ds<dt.那么我们肯定优先加入只有t点的边,然后次优先加入只有s的边,最后再加入既有s又有t的边。

③ds==dt.那么我们跑两遍即可,第一遍优先加入只有s点的边,然后次优先加入只有t的边,最后再加入既有s又有t的边。第二遍反过去,优先加入只有t点的边,然后次优先加入只有s的边,最后再加入既有s又有t的边。


#include<stdio.h>#include<string.h>#include<algorithm>using namespace std;struct node{    int x,y,w,use;}a[550000];int f[550000];int cmp(node a,node b){    return a.w<b.w;}int find(int a){    int r=a;    while(f[r]!=r)    r=f[r];    int i=a;    int j;    while(i!=r)    {        j=f[i];        f[i]=r;        i=j;    }    return r;}void merge(int a,int b){    int A,B;    A=find(a);    B=find(b);    if(A!=B)    f[B]=A;}int main(){    int n,m;    while(~scanf("%d%d",&n,&m))    {        int s,t,ds,dt;        for(int i=1;i<=n;i++)f[i]=i;        for(int i=0;i<m;i++)scanf("%d%d",&a[i].x,&a[i].y);        scanf("%d%d%d%d",&s,&t,&ds,&dt);        int vals,valt;        if(ds>dt)vals=1,valt=2;        else vals=2,valt=1;        for(int i=0;i<m;i++)        {            a[i].use=0;            if(a[i].x==s||a[i].y==s)a[i].w=vals;            if(a[i].x==t||a[i].y==t)a[i].w=valt;        }        int cnt=0;        sort(a,a+m,cmp);        int dds=0,ddt=0;        for(int i=0;i<m;i++)        {            if(a[i].w==0)            {                if(find(a[i].x)!=find(a[i].y))                {                    cnt++;                    a[i].use=1;                    merge(a[i].x,a[i].y);                }            }            else            {                if(find(a[i].x)!=find(a[i].y))                {                    if(a[i].x==s||a[i].y==s)                    {                        if(dds==ds)continue;                        dds++;                    }                    if(a[i].x==t||a[i].y==t)                    {                        if(ddt==dt)continue;                        ddt++;                    }                    cnt++;                    a[i].use=1;                    merge(a[i].x,a[i].y);                }            }        }        if(dds<=ds&&ddt<=dt&&cnt==n-1)        {            printf("Yes\n");            for(int i=0;i<m;i++)            {                if(a[i].use==1)                printf("%d %d\n",a[i].x,a[i].y);            }        }        else //如果不行再反向跑一遍。        {            for(int i=1;i<=n;i++)f[i]=i;            int vals,valt;            if(ds>=dt)vals=1,valt=2;            else vals=2,valt=1;            for(int i=0;i<m;i++)            {                a[i].use=0;                if(a[i].x==s||a[i].y==s)a[i].w=vals;                if(a[i].x==t||a[i].y==t)a[i].w=valt;            }            int cnt=0;            sort(a,a+m,cmp);            int dds=0,ddt=0;            for(int i=0;i<m;i++)            {                if(a[i].w==0)                {                    if(find(a[i].x)!=find(a[i].y))                    {                        cnt++;                        a[i].use=1;                        merge(a[i].x,a[i].y);                    }                }                else                {                    if(find(a[i].x)!=find(a[i].y))                    {                        if(a[i].x==s||a[i].y==s)                        {                            if(dds==ds)continue;                            dds++;                        }                        if(a[i].x==t||a[i].y==t)                        {                            if(ddt==dt)continue;                            ddt++;                        }                        cnt++;                        a[i].use=1;                        merge(a[i].x,a[i].y);                    }                }            }            if(dds<=ds&&ddt<=dt&&cnt==n-1)            {                printf("Yes\n");                for(int i=0;i<m;i++)                {                    if(a[i].use==1)                    printf("%d %d\n",a[i].x,a[i].y);                }            }            else            {                printf("No\n");            }        }    }}













0 0
原创粉丝点击